% Muuttujien esittely
N = 10; % N tasoa, kullakin tasolla sek ptevi ett ptemttmi

% Alustetaan kuvauksen matriisit
A = zeros(3*N, 3*N); % varataan ylimrist tilaa, poistetaan se myhemmin
B = zeros(2*N, 1);
% Koska mitataava suure = tila, y = x eli C = I ja D = 0.
C = eye(2*N); 
D = zeros(2*N, 1);

% Annetaan arvot muuttujille
% Kuvausmatriisi tytetn 2x4 matriiseilla AA:
AA = [0.6, 0.1; ... % ei-ylenevt: 60% ptevist silyy ptevin, 10% eppt. ptevityy
    0.0, 0.7; ...   % ei-ylenevt: 0% ptevist epptevityy, 70% epptevist pysyy eppt.
    0.2, 0.0; ...   % ylenevt: 20% ptevist pysyy ptevin, 0% epptevist ptevityy.
    0.1, 0.1];      % ylenevt: 10% ptevist tulee eppteviksi, 10% eppt. pysyy epptevin
% sek ptevist ett epptevist lopettaa 10%: molempien sarakkeiden
% summa = 0.9.

for i=1:2:(2*N)   
   A(i:i+3,i:i+1) = AA;
end
% Leikataan A:sta ylimriset pois
A = A(1:2*N, 1:2*N);
% Korjataan ylimmn tason tyntekijiden osalta:
A(end-1, end-1) = 0.9; % 90% ptevist jatkaa
A(end, end)     = 0.8; % 80% epptevist jatkaa (10% ptevityy)

u = 55;   % Uusia tyntekijit vuodessa
B(1)=0.9; % Uusista tyntekijist 90% on ptevi
B(2)=0.1; % ... ja 10% epptevi

% Alustetaan viel tyntekijmrt (p = ptevien osuus):
p = 0.5;
for i=1:2:2*N
   x0(i)    =   100-10*(i-1) * p;       % Ptevt
   x0(i+1)  =   100-10*(i-1) * (1-p);   % Epptevt
end

% Ajetaan simulaatio:
simOut = sim('lh1t3_mdl');
time = simOut.tout;
y = simOut.yout;

% Piirretn kuvaaja
% Asetetaan vrikartta kuvaajan viivoille
cmap=lines(10);
hold on
for i=1:size(y,2)
    if(mod(i,2)==0)
        MarkerSymbol='x';
    else
        MarkerSymbol='o';
    end
    plot(time, y(:,i),'Marker',MarkerSymbol,'MarkerSize',8, 'Color',cmap(i,:),'LineWidth', 2);
end
hold off

% Luodaan kuvatekstit
s = {[N, 1]};
for i = 1:N
    s{i} = sprintf('Taso %d', i);
end
legend(s, 'Location', 'NorthWest')
grid on

ylabel('K_j(t)/(K_j(t)+I_j(t))','FontSize',14)
xlabel('t','FontSize',14)
title('Ptevien ja epptevien tyntekijiden suhde','FontSize',14)
